blob: 01f100d2f91c4d45d12f34b3441779dd167f4d9d [file] [log] [blame]
Omari Stephens6e3c34d2015-04-14 18:40:33 -07001#!/bin/bash
2
3# Copyright (C) 2010 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17
18# A library script to help other scripts run within an Android build environment, or while deployed
19# on a target host. Intended to be used with the `source` bash built-in command. Defines the
20# following environment variables:
21# JAVA_VERSION, RDBG_FLAG, TF_PATH, TRADEFED_OPTS
22#
23# It will react to the following environment variables, if they are set:
24# TF_DEBUG, TRADEFED_OPTS_FILE
25
26
27checkPath() {
28 if ! type -P "$1" &> /dev/null; then
Julien Desprezd2bc1e12019-08-29 16:32:27 -070029 >&2 echo "Unable to find $1."
Omari Stephens6e3c34d2015-04-14 18:40:33 -070030 exit
31 fi;
32}
33
34checkFile() {
35 if [ ! -f "$1" ]; then
Julien Desprezd2bc1e12019-08-29 16:32:27 -070036 >&2 echo "Unable to locate $1"
Omari Stephens6e3c34d2015-04-14 18:40:33 -070037 exit
38 fi;
39}
40
Guang Zhu8fd08eb2019-08-13 10:58:33 -070041# All to specify an alternative Java binary, other than the one on PATH
42TF_JAVA="java"
43if [ ! -z "${TF_JAVA_HOME}" ]; then
44 # following similar convention as JAVA_HOME
45 TF_JAVA=${TF_JAVA_HOME}/bin/java
46fi
47
48checkPath ${TF_JAVA}
Omari Stephens6e3c34d2015-04-14 18:40:33 -070049
50# check java version
Guang Zhu8fd08eb2019-08-13 10:58:33 -070051java_version_string=$(${TF_JAVA} -version 2>&1)
Julien Desprez723fa9a2019-08-28 18:55:00 -070052JAVA_VERSION=$(echo "$java_version_string" | grep 'version [ "]\(1\.8\|9\|11\).*[ "]')
Omari Stephens6e3c34d2015-04-14 18:40:33 -070053if [ "${JAVA_VERSION}" == "" ]; then
Julien Desprezd2bc1e12019-08-29 16:32:27 -070054 >&2 echo "Wrong java version. 1.8, 9 or 11 is required. Found $java_version_string"
55 >&2 echo "PATH value:"
56 >&2 echo "$PATH"
Hector Tellez9f1f8072018-03-27 17:11:32 -070057 exit 8
Omari Stephens6e3c34d2015-04-14 18:40:33 -070058fi
59
Julien Desprez723fa9a2019-08-28 18:55:00 -070060# check if java is above 9 and supports add-opens
61JAVA_VERSION=$(echo "$java_version_string" | grep 'version [ "]\(9\|11\).*[ "]')
62if [ "${JAVA_VERSION}" != "" ]; then
63 ADD_OPENS_FLAG="--add-opens=java.base/java.nio=ALL-UNNAMED --add-opens=java.base/sun.reflect.annotation=ALL-UNNAMED"
64fi
65
Omari Stephens6e3c34d2015-04-14 18:40:33 -070066# check debug flag and set up remote debugging
67if [ -n "${TF_DEBUG}" ]; then
68 if [ -z "${TF_DEBUG_PORT}" ]; then
69 TF_DEBUG_PORT=10088
70 fi
71 RDBG_FLAG="-agentlib:jdwp=transport=dt_socket,server=y,suspend=y,address=${TF_DEBUG_PORT}"
72fi
73
74# first try to find TF jars in same dir as this script
75CUR_DIR=$(dirname "$0")
Julien Desprez5f390442015-11-20 23:20:44 +000076TF_JAR_DIR=$(dirname "$0")
Omari Stephens6e3c34d2015-04-14 18:40:33 -070077if [ -f "${CUR_DIR}/tradefed.jar" ]; then
78 TF_PATH="${CUR_DIR}/*"
79elif [ ! -z "${ANDROID_HOST_OUT}" ]; then
80 # in an Android build env, tradefed.jar should be in
81 # $ANDROID_HOST_OUT/tradefed/
82 if [ -f "${ANDROID_HOST_OUT}/tradefed/tradefed.jar" ]; then
83 # We intentionally pass the asterisk through without shell expansion
84 TF_PATH="${ANDROID_HOST_OUT}/tradefed/*"
Julien Desprez5f390442015-11-20 23:20:44 +000085 TF_JAR_DIR="${ANDROID_HOST_OUT}/tradefed/"
Omari Stephens6e3c34d2015-04-14 18:40:33 -070086 fi
87fi
88
89if [ -z "${TF_PATH}" ]; then
Julien Desprezd2bc1e12019-08-29 16:32:27 -070090 >&2 echo "ERROR: Could not find tradefed jar files"
Omari Stephens6e3c34d2015-04-14 18:40:33 -070091 exit
92fi
93
jdesprez6c7fb832017-04-10 17:30:50 -070094# include any host-side test jars from suite
95if [ ! -z "${ANDROID_HOST_OUT_TESTCASES}" ]; then
96 for folder in ${ANDROID_HOST_OUT_TESTCASES}/*; do
jdesprez8689aa32018-03-15 09:36:13 -070097 for entry in "$folder"/*; do
98 if [[ "$entry" = *".jar"* ]]; then
99 TF_PATH=${TF_PATH}:$entry
100 fi
jdesprez6c7fb832017-04-10 17:30:50 -0700101 done
102 done
103fi
104
Omari Stephens6e3c34d2015-04-14 18:40:33 -0700105# set any host specific options
106# file format for file at $TRADEFED_OPTS_FILE is one line per host with the following format:
107# <hostname>=<options>
108# for example:
109# hostname.domain.com=-Djava.io.tmpdir=/location/on/disk -Danother=false ...
110# hostname2.domain.com=-Djava.io.tmpdir=/different/location -Danother=true ...
111if [ -e "${TRADEFED_OPTS_FILE}" ]; then
112 # pull the line for this host and take everything after the first =
113 export TRADEFED_OPTS=`grep "^$HOSTNAME=" "$TRADEFED_OPTS_FILE" | cut -d '=' -f 2-`
114fi